#include "lk_helper.h"
#include "utility.h"

XZ_shadow_reg sh_regs[8];
static Int timestamp=0;
REGPARM(1)
Int XZ_HELPER_get_inst (instr_info * ii)
{
     //VG_(printf) ("GET_INST =%d\n",ii->cur_inst);
     return ii->cur_inst;
}

REGPARM(1)
void XZ_HELPER_increment_inst (instr_info * ii)
{
     ii->cur_inst++;
}

void XZ_HELPER_debug_terminate() 
{
    VG_(exit)(-1);
}
REGPARM(3)
void XZ_HELPER_debug_print_reg(Addr addr, Int reg_num, Int reg_content)
{
    VG_(printf)("BREAK POINT @ %x , reg %d has the content of %d(%x)\n",
           addr, reg_num, reg_content,reg_content);
}

REGPARM(2)
void XZ_HELPER_debug_get(Int idx, Int arch_reg) 
{
    instr_info * ii=sh_regs[arch_reg].ii;
    Int inst=sh_regs[arch_reg].inst;
    if (ii) {
        VG_(printf) ("%d GET %d = (%x,%s,%s,%d -- %d)\n",idx,arch_reg,ii->orig_addr,
           ii->file, ii->fn, ii->line, inst);
    } else {
	VG_(printf) ("%d GET %d = no definition\n", idx, arch_reg);
    }
}

REGPARM(3)
void XZ_HELPER_debug_put(Int idx, instr_info * ii, Int inst) 
{
    if (ii) {
        VG_(printf) ("%d PUT (%x,%s,%s,%d -- %d) \n",idx,ii->orig_addr,
           ii->file, ii->fn, ii->line, inst);
    } else {
	VG_(printf) ("%d PUT no definition\n", idx);
    }
}

REGPARM(1)
void XZ_HELPER_debug(Int idx) 
{
    VG_(printf) ("%d\n",idx);
}

REGPARM(2)
void XZ_HELPER_init_lvs_new (UChar * old_esp, fun_entry * fe)
{
    UChar * lvs;
    Int i;
    lvs=old_esp;
    //VG_(printf) ("ESP=%x\n",old_esp);
    //*(UInt*)(lvs-4)=0;
    lvs+=LAST_PREDICATE+CD_TIMESTAMP_OFFSET-4;
    
    //lvs=esp+(PER_CD_SPACE-CD_TIMESTAMP_OFFSET);
    //VG_(printf)("Initialize %x-> +%d\n",lvs, fe->alloc_lv);
    for (i=0;i<fe->alloc_lv;i++) {
       //VG_(printf)("%s: set %x to 0\n",fe->fn->fn,lvs);
       *(UInt*)lvs=0;
       lvs+=PER_CD_SPACE;
    }
    //VG_(printf) ("Initialize done\n");
}

REGPARM(2)
void XZ_HELPER_init_lvs (UChar * ebp, fun_entry * fe)
{
    UChar * lvs;
    Int i;
    lvs=ebp-fe->orig_sp_offset;
    *(UInt*)(lvs-4)=0;
    lvs-=LAST_PREDICATE+CD_TIMESTAMP_OFFSET;
    
    //lvs=esp+(PER_CD_SPACE-CD_TIMESTAMP_OFFSET);
    //VG_(printf)("Initialize %x-> +%d\n",lvs, fe->alloc_lv);
    for (i=0;i<fe->alloc_lv-2;i++) {
       //VG_(printf)("%s: set %x to 0\n",fe->fn->fn,lvs);
       *(UInt*)lvs=0;
       lvs-=PER_CD_SPACE;
    }
    //VG_(printf) ("Initialize done\n");
}
#ifdef TRACK_ARGV
REGPARM(2)
void XZ_HELPER_track_argv(Int argc, Char ** argv)
{
    Int i,j;
    Char * arg;
    VG_(printf)("ARGC=%d\n",argc);
    for (i=1;i<argc;i++) {
       arg=argv[i];
       VG_(printf) ("ARGV[%d]=%s\n",i, arg);
       for (j=0;j<VG_(strlen)(arg);j++) {
	  set_ii_vbytes4_ALIGNED((Addr)(arg+j),INPUT_RELEVANT);
          set_inst_vbytes4_ALIGNED((Addr)(arg+j),arg[j]);
       }//j
    }//i
}
#endif

#ifdef INTER_CD
//create dummy data dep which is acting as interprocedural CD
REGPARM(2)
void XZ_HELPER_create_dummy_CD(instr_info * ii,UInt * esp)
{
     set_ii_vbytes4_ALIGNED(esp,ii);
     set_inst_vbytes4_ALIGNED(esp,ii->cur_inst);
     VG_(printf) ("CALL SITE define %x as (%d,%d)\n",esp, ii->id, ii->cur_inst);
}

/*
REGPARM(2)
void XZ_HELPER_create_dummy_CD(instr_info * ii, Int uport)
{

    insert_dependence(&ii->uports[uport],ii->cur_inst, sh_regs[R_ESP].ii,sh_regs[R_ESP].inst);
    sh_regs[R_ESP].ii=ii;
    sh_regs[R_ESP].inst=ii->cur_inst;

    
}
*/
#endif
//setup the control dependence for ii
REGPARM(2)
void XZ_HELPER_setup_CD_new (instr_info * ii, UChar * ebp)
{
        Int i;
        UInt max_ts=0;
        UInt ts;
        UChar * lvs;
        instr_info * r_ii;
        Int r_inst;
        Int lv_idx;
        Int start_printing=0;
        lvs=ebp;
        UChar * old_ebp;
        
        sk_assert(ii->bb!=NULL);
        instr_info * bb=ii->bb;
        //VG_(printf) ("TRY TO SET UP CD for %x, cd_cnt=%d\n",bb->orig_addr, bb->cd_cnt); 
#ifdef INTER_CD
	if (!bb->cd_cnt) {//no CD, which means it is a inter CD
	    if (ii->fe->cd_available) {
		old_ebp=ebp+ii->fe->alloc_lv*PER_CD_SPACE+LAST_PREDICATE;
		r_ii=get_ii_vbytes4_ALIGNED(old_ebp+4);
                r_inst=get_inst_vbytes4_ALIGNED(old_ebp+4);
             } else {
		r_ii=get_ii_vbytes4_ALIGNED(ebp+4);
                r_inst=get_inst_vbytes4_ALIGNED(ebp+4);
		old_ebp=ebp;
	     }

             VG_(printf) ("INTER CD get define at %x as (%x,%d)\n",old_ebp, r_ii, r_inst);
	     if (r_ii==0xFFFFFFFF) return;
             VG_(printf) ("\tINTER CD r_ii=%d)\n", r_ii->id);
             insert_dependence(&ii->uports[0], ii,ii->cur_inst, r_ii,r_inst);
	    return;
        }
#endif
        for (i=0;i<bb->cd_cnt;i++) {
                instr_info * cd=bb->cds[i];
                //cd->lv_idx==-1 means that no local variable has been assigned to it.
                //if (cd->lv_idx<0) continue;
                ts=*((UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_TIMESTAMP_OFFSET-4));
                //if (start_printing)
          
          /*       
		    VG_(printf) ("%d(%x):ebp=%x lv_idx=%d(%d) ts(%x)=%d, r_ii=%x, r_inst=%x\n", i,cd->orig_addr, lvs, cd->lv_idx,ii->fe->alloc_lv, 
                        (UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_TIMESTAMP_OFFSET-4), ts,
                        ((UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_II_OFFSET-4)),
                        ((UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_INST_OFFSET-4)));                
          */           
                
                if (ts>max_ts) {
                        max_ts=ts;
                        lv_idx=cd->lv_idx;
                        r_ii=(instr_info*) *((UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_II_OFFSET-4));                
                        r_inst=*((UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_INST_OFFSET-4));              
                }
        }


        if (max_ts==0) {
                return ;
        }
        sk_assert(r_ii!=NULL);

        //sk_assert(r_ii->pred_ii!=NULL);
        //VG_(printf) ("CD: on %x (%s, %s, %d)\n",r_ii->orig_addr, r_ii->file, r_ii->fn, r_ii->line);
        //insert_dependence(&ii->uports[0],ii->cur_inst, r_ii->pred_ii,r_inst);
        //VG_(printf)("About to insert ctrl dep...\n");
        insert_dependence(&ii->uports[0], ii,ii->cur_inst, r_ii,r_inst);
}


//setup the control dependence for ii
REGPARM(2)
void XZ_HELPER_setup_CD (instr_info * ii, UChar * ebp)
{
        Int i;
        UInt max_ts=0;
        UInt ts;
        UChar * lvs;
        instr_info * r_ii;
        Int r_inst;
        Int lv_idx;
        Int start_printing=0;
        lvs=ebp - ii->fe->orig_sp_offset-LAST_PREDICATE;
	
        sk_assert(ii->bb!=NULL);
        instr_info * bb=ii->bb;
        for (i=0;i<bb->cd_cnt;i++) {
                instr_info * cd=bb->cds[i];
                //cd->lv_idx==-1 means that no local variable has been assigned to it.
                //if (cd->lv_idx<0) continue;
                ts=*((UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_TIMESTAMP_OFFSET));
                //if (start_printing)
		    /*VG_(printf) ("%d: lv_idx=%d(%d) ts(%x)=%d, r_ii=%x, r_inst=%d\n", i, cd->lv_idx,ii->fe->alloc_lv, 
                        (UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_TIMESTAMP_OFFSET), ts,
                        *((UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_II_OFFSET)),
                        *((UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_INST_OFFSET)));                
                      */
                if (ts>max_ts) {
                        max_ts=ts;
                        lv_idx=cd->lv_idx;
                        r_ii=(instr_info*) *((UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_II_OFFSET));                
                        r_inst=*((UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_INST_OFFSET));                }
        }

        if (start_printing) {
             //VG_(printf) ("%s,max_ts=%d, EBP=%x, CD BDD[%x]=%x, be->orig_sp_offset=%d, be->addr=%x, be->lv_idx=%d\n",be->fe->fn->fn,max_ts,(UInt)ebp,PER_CD_SPACE*lv_idx+CD_TIMESTAMP_OFFSET
             //     +be->fe->orig_sp_offset+LAST_PREDICATE,r,be->fe->orig_sp_offset, be->orig_addr, lv_idx);
        }

        if (max_ts==0) {
                return ;
        }
        sk_assert(r_ii!=NULL);
        //sk_assert(r_ii->pred_ii!=NULL);
        //insert_dependence(&ii->uports[0],ii->cur_inst, r_ii->pred_ii,r_inst);
        insert_dependence(&ii->uports[0], ii,ii->cur_inst, r_ii,r_inst);
}

#ifdef VALUE_WANTED
REGPARM(2)
void XZ_HELPER_trace_value1(instr_info * ii,UInt value)
{
    UInt v=value & 0xff;
    //VG_(printf)("insert (1)%x @ <%x,%d>\n",v, ii->orig_addr, ii->cur_inst);
    
    insert_value(ii,v);
    //insert_value_base(ii,value & 0xff,base);
    //VG_(printf)("insert done\n");
}

REGPARM(2)
void XZ_HELPER_trace_value2(instr_info * ii, UInt value)
{
    UInt v=value & 0xffff;
    //VG_(printf)("insert (2)%x @ <%x,%d>\n",v, ii->orig_addr, ii->cur_inst);
    
    insert_value(ii,v);
     
}

REGPARM(2)
void XZ_HELPER_trace_value4(instr_info * ii, UInt value)
{
    //VG_(printf)("insert %x @ <%x,%d>\n",value, ii->orig_addr, ii->cur_inst);
    
    insert_value(ii,value);
    //insert_value_base(ii,value,base);
    //VG_(printf)("insert done\n");
}

/*

REGPARM(2)
void XZ_HELPER_trace_value(instr_info * ii, UInt value)
{
    //VG_(printf)("insert %x @ <%x,%d>\n",value, ii->orig_addr, ii->cur_inst);
    
    insert_value(ii,value);
    //VG_(printf)("insert done\n");
}
*/
#endif 

#ifdef TIMESTAMPED
REGPARM(1)
void XZ_HELPER_trace_timestamp(instr_info * ii)
{
    //VG_(printf)("insert %x @ <%x,%d>\n",timestamp, ii->orig_addr, ii->cur_inst);
    //VG_(printf)("XXX Trace ts=%d for %x\n",timestamp,ii->orig_addr); 
    insert_timestamp(ii,timestamp++);
    //VG_(printf)("insert done\n");
}
REGPARM(2)
void XZ_HELPER_trace_control_flow(instr_info * bb, Addr branch_pc)
{
    insert_control_flow(bb, branch_pc);
}
#endif 

//port 0 is CD, port 1 is addr, port 2 is mem
REGPARM(3)
void XZ_HELPER_pred_dep (instr_info * ii, Int uport, instr_info * def_ii)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[uport], ii, ii->cur_inst, def_ii, def_ii->cur_inst-1);
}


//port 0 is CD, port 1 is addr, port 2 is mem
REGPARM(3)
void XZ_HELPER_reg_dep_port1 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[1], ii, ii->cur_inst, def_ii, def_inst);
}

REGPARM(3)
void XZ_HELPER_reg_dep_port2 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[2], ii, ii->cur_inst, def_ii, def_inst);
}

REGPARM(3)
void XZ_HELPER_reg_dep_port3 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[3], ii, ii->cur_inst, def_ii, def_inst);
}

REGPARM(3)
void XZ_HELPER_reg_dep_port4 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[4], ii, ii->cur_inst, def_ii, def_inst);
}

REGPARM(3)
void XZ_HELPER_reg_dep_port5 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[5], ii, ii->cur_inst, def_ii, def_inst);
}

REGPARM(3)
void XZ_HELPER_reg_dep_port6 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[6], ii, ii->cur_inst, def_ii, def_inst);
}


REGPARM(3)
void XZ_HELPER_load_mem_dep (instr_info * ii, Int uport, Addr a)
{
     instr_info * mem_def_ii;
     Int mem_def_inst;
     //DEBUG
//#define DEBUG     
#ifdef DEBUG
     VG_(printf) ("LOAD_MEM_DEP START ii=%d(%x,%s,%s,%d), inst=%d, addr=%x\n",ii->id, ii->orig_addr, ii->file, ii->fn, ii->line, ii->cur_inst,a);
#endif
     mem_def_ii=get_ii_vbytes4_ALIGNED(a);
     mem_def_inst=get_inst_vbytes4_ALIGNED(a);
     if (!mem_def_ii || (UInt)mem_def_ii==0xffffffff) {
         //VG_(printf) ("LOAD_MEM_DEP End\n");
         return;
     }
#ifdef TRACK_INPUT
     if ((UInt)mem_def_ii==INPUT_RELEVANT) {
//#ifdef DEBUG
     	 VG_(printf) ("INPUT RELATED ii=%d(%x,%s,%s,%d), inst=%d, value=%x '%c' addr=%x\n",ii->id, ii->orig_addr, ii->file, ii->fn, ii->line, ii->cur_inst,mem_def_inst,mem_def_inst,a);
//#endif
         set_input_relevance(ii,mem_def_inst);
         return;
     }
#endif
     //DEBUG
#ifdef DEBUG
     VG_(printf) ("\tdef_ii=<%s,%s,%d>, inst=%d\n", mem_def_ii->file, mem_def_ii->fn, mem_def_ii->line, mem_def_inst);
#endif
     insert_dependence(&ii->uports[uport], ii, ii->cur_inst, mem_def_ii, mem_def_inst);
     //VG_(printf) ("LOAD_MEM_DEP End\n");
}

REGPARM(3)
void XZ_HELPER_store_mem_dep(instr_info * ii,Int size, Addr a)
{
#ifdef DEBUG
     VG_(printf) ("store %x ii=%d<%s,%s,%d>, inst=%d, a=%x\n", a, ii->id,ii->file, ii->fn, ii->line, ii->cur_inst,a);
#endif
#ifndef BYTE_GRANUITY
     set_ii_vbytes4_ALIGNED(a,ii);
     set_inst_vbytes4_ALIGNED(a,ii->cur_inst);
#else
     switch (size) {
	case 1:
     	 set_ii_vbytes4_ALIGNED(a,ii);
         set_inst_vbytes4_ALIGNED(a,ii->cur_inst);
	 break;
       case 2:
         set_ii_vbytes4_ALIGNED(a,ii);
         set_inst_vbytes4_ALIGNED(a,ii->cur_inst);
         set_ii_vbytes4_ALIGNED(a+1,ii);
         set_inst_vbytes4_ALIGNED(a+1,ii->cur_inst);
	 break;
       case 4:
         set_ii_vbytes4_ALIGNED(a,ii);
         set_inst_vbytes4_ALIGNED(a,ii->cur_inst);
         set_ii_vbytes4_ALIGNED(a+1,ii);
         set_inst_vbytes4_ALIGNED(a+1,ii->cur_inst);
         set_ii_vbytes4_ALIGNED(a+2,ii);
         set_inst_vbytes4_ALIGNED(a+2,ii->cur_inst);
         set_ii_vbytes4_ALIGNED(a+3,ii);
         set_inst_vbytes4_ALIGNED(a+3,ii->cur_inst);
         break;
      }
#endif

}

REGPARM(1)
Int XZ_HELPER_get_timestamp(UInt novalue)
{
#ifndef TIMESTAMPED
     return timestamp;
#else
     return timestamp++;
#endif
}
REGPARM(2)
void XZ_HELPER_debug_load_value(Addr a, UInt value)
{
    VG_(printf) ("[%x]=%x\n", a, value);
}

REGPARM(3)
void XZ_HELPER_debug_store_value(Addr instr, Addr a, UInt value)
{
    VG_(printf) ("STORE @ %x put [%x]= %x\n", instr, a,value);
}
REGPARM(1)
void XZ_HELPER_debug_EBP_set_value(UInt value,Addr bb)
{
    VG_(printf) ("+EBP is set to %x at %x\n", value,bb);
}
REGPARM(1)
void XZ_HELPER_debug_EBP_get_value(UInt value, Addr bb)
{
    VG_(printf) ("get +EBP=%x at %x\n", value,bb);
}

REGPARM(1)
void XZ_HELPER_debug_BB(Addr a)
{
    VG_(printf) ("+BB+ %x\n", a);
}
