#ifndef __SLICING_H
#define __SLICING_H
typedef unsigned int Addr;
typedef int Int;
typedef char Char;
typedef unsigned int UInt;
typedef unsigned char          Bool;
#define False                  ((Bool)0)
#define True                   ((Bool)1)

#include "graph_common.h"
extern void slice_one_step_depth_first(slice_node * current_node, slice_node ** new_wl);
extern slice_node *  get_dice_criteria (Char * sim_output);
//extern slice_node *  get_dice_criteria (Char * sim_output, Int err_id, Int err_inst);
extern void read_instr_dic(Char * file);
extern void read_dependence(Char * file);
//extern void print_slice_list(slice_node * head);
extern void load_traced_file ( Char* filename );
extern void load_error_file ( Char* filename );
extern slice_node * insert_node_into_list(instr_info* , Int, slice_node*);
extern Int print_slice_list(slice_node*);
extern Int print_predicate_list(slice_node*);
extern Int stat_slice_list(slice_node*);
extern slice_node * find_input_criteria(Char*);
extern slice_node * slice_to_traced_cut(slice_node*);
extern slice_node * slice_from_traced_cut(slice_node*);
extern slice_node * slice_from_breadth_first(slice_node * work_list,int * step);
//extern slice_node * filter(slice_node*);
extern slice_node * forward_slice(slice_node*);
extern slice_node * forward_slice_bf(slice_node*);
extern slice_node * qsort_list(slice_node *);
extern slice_node * qsort_list_by_step_timestamp(slice_node *);
extern int print_slice_list_condensed(slice_node *);
extern int print_slice_list_condensed_w_search(slice_node *,Int, Bool *);
extern void construct_forward_pdg();
extern slice_node * union_slice(slice_node *, slice_node*);
extern slice_node * diff_slice(slice_node *, slice_node*);
extern slice_node * intersect_slice(slice_node *, slice_node*);
extern slice_node*  read_slice_list(Char*);
extern void write_slice_list(Char*,slice_node*);
extern void write_predicate_list(Char*,slice_node*);
extern void stat_executed_LOC();
extern void clear_all_visited_bits();
extern slice_node * error_slice(slice_node * work_list);
extern slice_node * certify_slice(slice_node * work_list,Bool dice);
extern void step_debug_certify_slice();
extern Int get_vs_visited_bit(instr_info * ii, Int inst);
extern Int get_forward_visited_bit(instr_info * ii, Int inst);
extern void clear_backward_pdg();
extern void compute_propagatability();
extern slice_node * get_all_output(Char*);
extern void set_threshold(Int t);

extern slice_node * relevant_slice(slice_node * work_list);
extern slice_node * expand_once (slice_node * slice, Int err_ii_id, Int err_inst, Int num_expand,Bool proved, slice_node * (*f) (slice_node*));
extern slice_node * read_proved_potential_edges (Int err_ii_id, Int err_inst, Int num_expand);
#endif
