#ifndef __UTILITY_H
#define __UTILITY_H

#include "vg_skin.h"
#include "vg_constants_skin.h"

#include "graph_common.h"


extern Bool is_instr_traced(Addr);
extern void get_debug_info(Addr instr_addr, Char file[FILE_LEN],
                           Char fn[FN_LEN], Int* line);
extern fun_entry * get_fun_entry(Addr, fileCC * filecc, fnCC * fncc);
extern fun_entry * get_fun_entry_new(Addr, fileCC * filecc, fnCC * fncc);
extern void read_cd_fun_entries(Char *);
extern void get_bb_info(Addr bb_addr, fileCC ** filecc, fnCC ** fncc, Int *line);
extern instr_info* get_instr_info(Addr instr_addr,fun_entry * fe, Int line, Int uport, Bool* new_instr, Bool look_for_bb);
//extern instr_info * get_instr_info (Addr, Addr, Int);
extern void load_traced_file(Char * );
extern void print_cb(UCodeBlock* cb);

static Bool read_control_dep(Addr fun_addr, Char * fn, fun_entry * fe);
fun_entry * get_fun_entry_dummy(fileCC * filecc, fnCC * fncc);

extern void * VG_(XZ_get_threadstate_3_arg) (ThreadId tid, UInt * arg1, UInt * arg2, UInt * arg3);
extern void * VG_(XZ_get_threadstate_exec_argv) (ThreadId tid, UInt * argv);
extern void  VG_(XZ_block_syscall) (void * );
extern void  VG_(XZ_set_res)(void * , Int);
extern void *VG_(XZ_before_fork)(ThreadId);
extern void  VG_(XZ_after_fork)(ThreadId,void*);
extern size_t read_from_log(Int fid, Char * bf, size_t count);
extern val_stream * create_val_stream();
extern void insert_dependence(val_stream ** p_vs, instr_info * ii, Int use_inst, instr_info * def_ii, Int def_inst);
extern void insert_value(instr_info * ii, UInt value);
extern instr_info * search_for_bb(Addr orig_addr, fun_entry * fe);

extern void init_shadow_memory(void);

extern void write_buffer_trace ( Char * file);
extern void write_instr_dic ( Char * file);
extern void read_instr_dic (Char * file);
extern void write_dependence ( Char * file);
extern void read_dependence (Char * file);
extern void set_input_relevance(instr_info*, UInt);

#ifdef TIMESTAMPED
extern void insert_timestamp(instr_info * ii, UInt ts);
extern void insert_control_flow(instr_info * bb, Addr branch_pc);
#endif

#ifdef RELEVANT_SLICING
extern UInt __inline__ get_ts_vbytes4_ALIGNED ( Addr a );
extern void __inline__ set_ts_vbytes4_ALIGNED ( Addr a, UInt bytes );
#endif

extern UInt __inline__ get_ii_vbytes4_ALIGNED ( Addr a );
extern void __inline__ set_ii_vbytes4_ALIGNED ( Addr a, UInt bytes );
extern UInt __inline__ get_inst_vbytes4_ALIGNED ( Addr a );
extern void __inline__ set_inst_vbytes4_ALIGNED ( Addr a, UInt bytes );
#endif

// Declarations for the dependence buffer
#define DEP_BUFFER_SIZE 100000
extern Dep_Buffer_Element * depBuffer[DEP_BUFFER_SIZE];
extern UInt nextDepBufferSlot;
extern void initDepBuffer();
